<?php
/**
 * @version 0.2 : selectflexiitem.php 2010-01-10 
 * @package Joomla
 * @subpackage FLEXIcontent
 * @subpackage plugin.selectflexiitem
 * @license GNU/GPL v2
 *
 * Orignal file : selectmultiple.php
 * @version 1.0 $Id: selectmultiple.php 175 2009-11-07 10:24:30Z vistamedia $
 * @package Joomla
 * @subpackage FLEXIcontent
 * @subpackage plugin.selectmultiple
 * @copyright (C) 2009 Emmanuel Danan - www.vistamedia.fr
 * @license GNU/GPL v2
 *
 * FLEXIcontent is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 */
defined( '_JEXEC' ) or die( 'Restricted access' );

//jimport('joomla.plugin.plugin');
jimport('joomla.event.plugin');

class plgFlexicontent_fieldsSelectflexiitem extends JPlugin
{
	function plgFlexicontent_fieldsSelectflexiitem( &$subject, $params )
	{
		parent::__construct( $subject, $params );
        JPlugin::loadLanguage('plg_flexicontent_fields_selectflexiitem', JPATH_ADMINISTRATOR);
	}

	
	function onDisplayField(&$field, $item)
	{
		// execute the code only if the field type match the plugin type
		if($field->field_type != 'selectflexiitem') return;

		// some parameter shortcuts
		$required 			= $field->parameters->get( 'required', 0 ) ;
		$size				= $field->parameters->get( 'size', 6 ) ;
		$default_values		= $field->parameters->get( 'default_values', '' ) ;
		$type				= $field->parameters->get( 'type', 0 ) ;
		
		//TODO : Filtrer par statut de contenu
		//$states				= $field->parameters->get( 'states', array( 0 => 1 )) ;
		$states = array( 0 => 1 );
		
		$required 	= $required ? ' class="required"' : '';
		$size	 	= $size ? ' size="'.$size.'"' : '';
		
		// initialise property
		if($item->version == 1 && $default_values) {
			$field->value = explode(",", $default_values);
		}

		if ($type) {
			
			//BOF Build Order Clause
			
			$order = $field->parameters->get( 'orderby' );
			
			switch ($order) {
				case 'date' :
				$filter_order		= 'i.created';
				$filter_order_dir	= 'ASC';
				break;
				case 'rdate' :
				$filter_order		= 'i.created';
				$filter_order_dir	= 'DESC';
				break;
				case 'alpha' :
				$filter_order		= 'i.title';
				$filter_order_dir	= 'ASC';
				break;
				case 'ralpha' :
				$filter_order		= 'i.title';
				$filter_order_dir	= 'DESC';
				break;
				case 'hits' :
				$filter_order		= 'i.hits';
				$filter_order_dir	= 'ASC';
				break;
				case 'rhits' :
				$filter_order		= 'i.hits';
				$filter_order_dir	= 'DESC';
				break;
				case 'order' :
				$filter_order		= 'rel.ordering';
				$filter_order_dir	= 'ASC';
				break;
				default :
				$filter_order		= 'rel.ordering';
				$filter_order_dir	= 'ASC';
				break;
			}
						
			$orderby 	= ' ORDER BY '.$filter_order.' '.$filter_order_dir.', i.title';
			//EOF Order Clause
			//BOF Build WHERE Clause with state
			//TODO Implementer le filtre par statut
			/*$where_state = "IN (";
			$cpt_state=0;					
			foreach($states as $state){
				$where_state.= $state;
				$cpt_state++;
				if($cpt_state<count($states)){
					$where_state.=",";	
				}
			}
			$where_state.=")";*/
			//EOF Build WHERE Clause
			
			$db =& JFactory::getDBO();
			$field_elements= 'SELECT id as value, title as text'
							  .' FROM #__content as i'
							  .' LEFT JOIN #__flexicontent_items_ext AS ie ON i.id=ie.item_id'
							  .' LEFT JOIN #__flexicontent_cats_item_relations AS rel ON rel.itemid = i.id AND rel.catid=i.catid'
							  .' WHERE ie.type_id='.$type
							  .$orderby;
							  
			$query = preg_match('#^select#i', $field_elements) ? $field_elements : '';
			$db->setQuery($query);
			
			$options = $db->loadObjectList();
			
			if (!$options) {
				$field->html = JText::_('FLEXI_FIELD_INVALID_QUERY');
			
			} else {
			
				$field->html	= JHTML::_('select.genericlist', $options, $field->name.'[]', 'multiple="multiple"'.$required.$size, 'value', 'text', $field->value);
			}

		} else { 

			$field->html = JText::_('FLEXI_FIELD_NO_TYPE_SELECTED');
		}
	}

	function onBeforeSaveField( $field, &$post, &$file )
	{
		// execute the code only if the field type match the plugin type
		if($field->field_type != 'selectflexiitem') return;
		if(!$post) return;
		
		// create the fulltext search index
		$searchindex = '';
		
		$pretext			= $field->parameters->get( 'pretext', '' ) ;
		$posttext			= $field->parameters->get( 'posttext', '' ) ;
		$remove_space		= $field->parameters->get( 'remove_space', 0 ) ;
		$type				= $field->parameters->get( 'type', 0 ) ;

		if($pretext) 	{ $pretext 	= $remove_space ? '' : $pretext . ' '; }
		if($posttext) 	{ $posttext	= $remove_space ? '' : ' ' . $posttext; }

		if ($type) {
			
			$db =& JFactory::getDBO();
			$field_elements= 'SELECT id as value, title as text'
							.' FROM #__content as i'
							.' LEFT JOIN #__flexicontent_items_ext as ie ON i.id=ie.item_id'
							.' WHERE ie.type_id='.$type
							.' AND i.state=1';
			$query = preg_match('#^select#i', $field_elements) ? $field_elements : '';
			$db->setQuery($query);
			$results = $db->loadObjectList();

			if (!$results) {
				$display = '';
			
			} else {

				$display = array();
				foreach($results as $result) {
					for($n=0, $c=count($post); $n<$c; $n++) {
						if ($result->value == $post[$n]) {
							$display[] = $pretext . $result->text . $posttext;
						}
					}
				}
				$searchindex	 = implode(' ', $display);
				$searchindex	.= ' | ';
				$field->search = $field->issearch ? $searchindex : '';
			}

		} else { 
			$field->html = JText::_('FLEXI_FIELD_NO_TYPE_SELECTED');
		}			
	}


	function onDisplayFieldValue(&$field, $item, $values=null, $prop='display')
	{
		// execute the code only if the field type match the plugin type
		if($field->field_type != 'selectflexiitem') return;
		
		$values = $values ? $values : $field->value ;

		// some parameter shortcuts
		$remove_space		= $field->parameters->get( 'remove_space', 0 ) ;
		$pretext			= $field->parameters->get( 'pretext', '' ) ;
		$posttext			= $field->parameters->get( 'posttext', '' ) ;
		$addlink 			= $field->parameters->get( 'addlink' ) ;
		$separatorf			= $field->parameters->get( 'separatorf' ) ;
		$opentag			= $field->parameters->get( 'opentag', '' ) ;
		$closetag			= $field->parameters->get( 'closetag', '' ) ;
		$type				= $field->parameters->get( 'type', 0 ) ;
		$displayway			= $field->parameters->get( 'displayway', 1 ) ;
		
		switch($separatorf)
		{
			case 0:
			$separatorf = '&nbsp;';
			break;

			case 1:
			$separatorf = '<br />';
			break;

			case 2:
			$separatorf = '&nbsp;|&nbsp;';
			break;

			case 3:
			$separatorf = ',&nbsp;';
			break;

			case 4:
			$separatorf = $closetag . $opentag;
			break;

			default:
			$separatorf = '&nbsp;';
			break;
		}
		
		if($pretext) 	{ $pretext 	= $remove_space ? $pretext : $pretext . ' '; }
		if($posttext) 	{ $posttext	= $remove_space ? $posttext : ' ' . $posttext; }

		if ($type) {
			
			$order = $field->parameters->get( 'orderby' );
			
			switch ($order) {
				case 'date' :
				$filter_order		= 'i.created';
				$filter_order_dir	= 'ASC';
				break;
				case 'rdate' :
				$filter_order		= 'i.created';
				$filter_order_dir	= 'DESC';
				break;
				case 'alpha' :
				$filter_order		= 'i.title';
				$filter_order_dir	= 'ASC';
				break;
				case 'ralpha' :
				$filter_order		= 'i.title';
				$filter_order_dir	= 'DESC';
				break;
				case 'hits' :
				$filter_order		= 'i.hits';
				$filter_order_dir	= 'ASC';
				break;
				case 'rhits' :
				$filter_order		= 'i.hits';
				$filter_order_dir	= 'DESC';
				break;
				case 'order' :
				$filter_order		= 'rel.ordering';
				$filter_order_dir	= 'ASC';
				break;
				default :
				$filter_order		= 'rel.ordering';
				$filter_order_dir	= 'ASC';
				break;
			}
						
			$orderby 	= ' ORDER BY '.$filter_order.' '.$filter_order_dir.', i.title';
			
			$db =& JFactory::getDBO();
			$field_elements= 'SELECT DISTINCT id as value, title as text'
							 .' FROM #__content as i'
							 .' LEFT JOIN #__flexicontent_fields_item_relations AS fi_rel ON i.id=fi_rel.value'
							 .' LEFT JOIN #__flexicontent_cats_item_relations AS rel ON rel.itemid = i.id AND rel.catid=i.catid'
							  .' WHERE fi_rel.field_id='.$field->id
							 .' AND fi_rel.item_id='.$item->id
							 .$orderby
							 ;
			$query = preg_match('#^select#i', $field_elements) ? $field_elements : '';
			$db->setQuery($query);
			echo $db->getErrorMsg();
			$results = $db->loadObjectList();			
			
			if (!$results) {
				$field->{$prop} = '';
			
			} else {

				$display = array();
				
				foreach($results as $result) {
/*					for($n=0, $c=count($values); $n<$c; $n++) {
						if ($result->value == $values[$n]) {*/
							$display_text = $pretext;
							if($addlink){
								$link="<a href=\"".JRoute::_(FlexicontentHelperRoute::getItemRoute($result->value))."\" >";
								$display_text.=$link;
							}
							($displayway) ? $display_text.= $result->text : $display_text.= $result->value;
							//$display_text.= $result->text;
							if($addlink){
								$display_text.="</a>";
							}
							$display_text.= $posttext;
							$display[]= $display_text;
						/*}
					}*/
				}
				
			$field->{$prop} = implode($separatorf, $display);
			$field->{$prop} = $opentag . $field->{$prop} . $closetag;
			}

		} else{
			$field->html = JText::_('FLEXI_FIELD_NO_TYPE_SELECTED');
				
		}
	}


	function onDisplayFilter(&$filter, $value='')
	{
		// execute the code only if the field type match the plugin type
		if($filter->field_type != 'selectflexiitem') return;

		// some parameter shortcuts

		$type				= $filter->parameters->get( 'type', 0 ) ;
		
		if ($type) {
			$db =& JFactory::getDBO();
			$field_elements= 'SELECT DISTINCT id as value, title as text'
							 .' FROM #__content as i'
							 .' LEFT JOIN #__flexicontent_fields_item_relations as fir ON i.id=fir.value'
							 .' WHERE fir.field_id='.$filter->id
							 ;
			$query = preg_match('#^select#i', $field_elements) ? $field_elements : '';
			$db->setQuery($query);
			$results = $db->loadObjectList();
			
			if (!$results) {
				$field->html = '';
			
			} else {
			
				$options = array();
				$options[] = JHTML::_('select.option', '', '-'.JText::_('All').'-');
				foreach($results as $result) {
					$options[] = JHTML::_('select.option', $result->value, $result->text);
				}
				$filter->html	= JHTML::_('select.genericlist', $options, 'filter_'.$filter->id, 'onchange="document.getElementById(\'adminForm\').submit();"', 'value', 'text', $value);
			}

		} else {
			$field->html = JText::_('FLEXI_FIELD_NO_TYPE_SELECTED');
		}
	}
}